#include <stdio.h>
#include <stdlib.h>

#define bool int
 
/*     */
struct node
{
  int data;
  struct node* left;
  struct node* right;
};
 
/*      */
void printLevelOrder(struct node* root)
{
  int h = height(root);
  int i;
 
	/* 
	  
	 ltr = 1,  -
	 ltr = 0,    
	*/
  bool ltr = 1;
  for(i=1; i<=h; i++)
  {
    printGivenLevel(root, i, ltr);
  }
}   
 
void printGivenLevel(struct node* root, int level, int ltr)
{
  if(root == NULL)
    return;
  if(level == 1)
    printf("%d ", root->data);
  else if (level > 1)
  {
    if(ltr)
    {
      printGivenLevel(root->left, level-1, ltr);
      printGivenLevel(root->right, level-1, ltr);
    }
    else
    {
      printGivenLevel(root->right, level-1, ltr);
      printGivenLevel(root->left, level-1, ltr);
    }
  }
}
 
/*     .*/
int height(struct node* node)
{
   if (node==NULL)
       return 0;
   else
   {
     int lheight = height(node->left);
     int rheight = height(node->right);
 
     if (lheight > rheight)
         return(lheight+1);
     else return(rheight+1);
   }
}
 
/*       */
struct node* newNode(int data)
{
  struct node* _node = (struct node*) malloc(sizeof(struct node));
  _node->data = data;
  _node->left = NULL;
  _node->right = NULL;
 
  return(_node);
}

/*      */
int getMaxWidth(struct node* root)
{
  int maxWdth = 0;
  int i;
  int width = 0 ;
  int h = height(root);
  for( i = 1; i< h; i++)
  {
    width =   getWidth(root, i);
    if(width > maxWdth)
        maxWdth  = width;
  }
  return maxWdth;
}

int getWidth(struct node* root,int level)
{
  if (!root) return 0;
  if (level == 1) return 1;
  else if (level > 1)
      return getWidth(root->left, level-1) +  getWidth(root->right, level-1);
  getWidth(root->right, level-1);
}

/*        */
int lookup(struct node* node, int target) 
{
  if (node == NULL) 
  {
    return(0);
  }
  else 
  {
    if (target == node->data) return(1);
    else 
    {
      if (target < node->data) return(lookup(node->left, target));
      else return(lookup(node->right, target));
    }
  }
} 

/*    */
int main()
{
  /*    */
  struct node *root  = newNode(8);
  /*     */
  root->left         = newNode(4);
  root->right        = newNode(12);
  root->left->left   = newNode(2);
  root->left->right  = newNode(6);
  root->right->left  = newNode(10);
  root->right->right = newNode(14);
  root->left->left->left  = newNode(1);
  root->right->right->right = newNode(25);
  root->left->left->left->left     = newNode(0);
  root->left->left->right    = newNode(3);
  root->right->right->right->right = newNode(100);
  root->right->right->right->left  = newNode(20);

  /*     */
  printLevelOrder(root);

  printf("\n: %d\n", height(root));
  printf("\n %d\n", getMaxWidth(root));

  printf("\n%d\n",lookup(root,100));
  printf("\n%d\n",lookup(root,33));

  return 0;
}